// ModifyBitmapColourDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ModifyBitmapColour.h"
#include "ModifyBitmapColourDlg.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CModifyBitmapColourDlg dialog

CModifyBitmapColourDlg::CModifyBitmapColourDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CModifyBitmapColourDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CModifyBitmapColourDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CModifyBitmapColourDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CModifyBitmapColourDlg)
	DDX_Control(pDX, IDC_FRAME_IMAGE_BEFORE, m_cImageFrameBefore);
	DDX_Control(pDX, IDC_FRAME_IMAGE, m_cImageFrame);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CModifyBitmapColourDlg, CDialog)
	//{{AFX_MSG_MAP(CModifyBitmapColourDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CModifyBitmapColourDlg message handlers


BOOL CModifyBitmapColourDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	CRect rect;
	m_cImageFrame.GetClientRect(&rect);
	int width = rect.Width();
	int height = rect.Height();

	CString sInputFile = "C:\\test.bmp"; // This is the bitmap we will try to load

	// Check bitmap exists
	FILE * ftest = fopen(sInputFile,"r");
	if (ftest==NULL)
	{
		AfxMessageBox(CString("Could not load ")+sInputFile);
	}
	else
	{
		// Create a copy of the bitmap which will remain unchanged
		m_bitmap_before_dc.CreateCompatibleDC(m_cImageFrame.GetDC());
		m_bitmap_handle_before = (HBITMAP)::LoadImage(NULL,sInputFile,IMAGE_BITMAP,0,0,LR_LOADFROMFILE);
		m_bitmap_before.Attach(m_bitmap_handle_before);
		m_bitmap_before_dc.SelectObject(m_bitmap_handle_before);

		// Create a copy of the bitmap which we will modify
		m_bitmap_after_dc.CreateCompatibleDC(m_cImageFrame.GetDC());
		m_bitmap_handle_after = (HBITMAP)::LoadImage(NULL,sInputFile,IMAGE_BITMAP,0,0,LR_LOADFROMFILE);
		m_bitmap_after.Attach(m_bitmap_handle_after);
		m_bitmap_after_dc.SelectObject(m_bitmap_handle_after);
		

		// Get the Bitmap 
		BITMAP bm;
		m_bitmap_after.GetBitmap(&bm); 

		// For simplicity, only work with 24-bit bitmaps
		if (bm.bmBitsPixel==24)
		{
		  int nSize = bm.bmWidthBytes*bm.bmHeight*bm.bmPlanes;
		  BYTE * bits = (BYTE *)malloc(nSize);
		  m_bitmap_after.GetBitmapBits(nSize,bits);
		  int i=0;

		  // These are the only 2 colours which we want the final bitmap to consist of.
		  int col1_r = 0, col1_g=135, col1_b=0;   // Dark green
		  int col2_r = 0, col2_g=0,   col2_b=135; // Dark blue

		  for (int nRow=0; nRow<bm.bmHeight; nRow++)
		  {
			  i = nRow*bm.bmWidthBytes;

			  for (int nCol=0; nCol<bm.bmWidth; nCol++)
			  {
				  int b = bits[i+0];
				  int g = bits[i+1];
				  int r = bits[i+2];

				  // Find the closest colour match for this pixel
				  double diff1 = sqrt(pow(b-col1_b,2)+pow(g-col1_g,2)+pow(r-col1_r,2));
				  double diff2 = sqrt(pow(b-col2_b,2)+pow(g-col2_g,2)+pow(r-col2_r,2));

				  if (diff1<diff2)
				  {
					  bits[i]=col1_b; bits[i+1]=col1_g; bits[i+2]=col1_r;
				  }
				  else
				  {
					  bits[i]=col2_b; bits[i+1]=col2_g; bits[i+2]=col2_r;
				  }

				  i+=3;
			  }
		  }
		  m_bitmap_after.SetBitmapBits(nSize,bits);
		}
		else
		{
			AfxMessageBox("Bitmap must be 24 bits!");
		}
	}

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CModifyBitmapColourDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CModifyBitmapColourDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CPaintDC dc(this);

		int width, height;

		// Display the "before" bitmap
		CRect rect_before;
		m_cImageFrameBefore.GetClientRect(&rect_before);
		CDC *pDC2 = m_cImageFrameBefore.GetDC();
		width = rect_before.Width();
		height = rect_before.Height();
		pDC2->BitBlt(0,0,width,height,&m_bitmap_before_dc,0,0,SRCCOPY);

		// Display the "after" bitmap
		CRect rect;
		m_cImageFrame.GetClientRect(&rect);
		CDC *pDC1 = m_cImageFrame.GetDC();
		width = rect.Width();
		height = rect.Height();
		pDC1->BitBlt(0,0,width,height,&m_bitmap_after_dc,0,0,SRCCOPY);

		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CModifyBitmapColourDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
